/******************************************************************************/
//
// Test Name: 	dummy
//
/*****************************************************************************************************************

(C) Copyright 2003 - Analog Devices, Inc.  All rights reserved.

File Name:		blink_led.asm

Date Modified:	5/16/03		KU		Rev 0.0

Software:       VisualDSP++3.1

Hardware:		BUB Board

Special Connections:  None

Purpose:		Show a basic example of using both cores 
				This uses a single dxe approach the whole project
				All memory sections are defined in the ldf file
				Code must be placed into 
					P0.asm for all code in CoreA L1
					P1.asm for all code in CoreB L1
					L2.asm for all code in shared L2 memory
					L3_SDRAM.asm for all code in shared L3 SDRAM
				Both cores are set up with an interrupt VT and can be placed in either SuperVisor or UserMode
				The correspoding code is in CA_startup.asm and CB_startup.asm	
				
				If you need to add other source file, copy the ldf file into your project directory and change the $OBJECTS section accordingly
			
				This example places some LED toggling in core A and a dummy main loop into core B
				Also, a dummy Buffer is placed into L2				
************************************************************************************************/

#include <cDefBF561.h>
#include <sysreg.h>
#include <ccblkfn.h>

void main_l2()
{

	while(1)
	{
		idle();
	}
}

// place a data buffer in shared L2
section("voldata") volatile int Dummy_L2_buffer[1024];


