	.module P1_AVR_ISRs.c
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\Steve\Desktop\P1AVR6~1\P1_AVR_ISRs.c
	.area vector(rom, abs)
	.org 80
	jmp _UART_RX_Interrupt
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\Steve\Desktop\P1AVR6~1\P1_AVR_ISRs.c
	.area vector(rom, abs)
	.org 88
	jmp _UART_TX_Interrupt
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\Steve\Desktop\P1AVR6~1\P1_AVR_ISRs.c
	.area vector(rom, abs)
	.org 64
	jmp _TIMER0_Compare_Interrupt
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\Steve\Desktop\P1AVR6~1\P1_AVR_ISRs.c
	.area vector(rom, abs)
	.org 36
	jmp _TIMER2_Compare_Interrupt
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\Steve\Desktop\P1AVR6~1\P1_AVR_ISRs.c
	.dbfunc e UART_RX_Interrupt _UART_RX_Interrupt fV
;           data -> R16
;        tmphead -> R18
	.even
_UART_RX_Interrupt::
	st -y,R2
	st -y,R3
	st -y,R4
	st -y,R5
	st -y,R16
	st -y,R18
	st -y,R19
	st -y,R24
	st -y,R25
	st -y,R30
	st -y,R31
	in R2,0x3f
	st -y,R2
	.dbline -1
	.dbline 88
; /**************************************************************
; 
;    Program Title:  P1 AVR Boot/Monitor
;    
;    Program Name:  P1_AVR_ISRs.c		  Version: 0.88
;    
;    Author:  SS	  					  Date:  August 10, 2005
;    
;    Compiled with ImageCraft ICCAVR Standard V6.29
;    
;    This file contains routines that implement the interrupt service routines 
;    for the P1 AVR Boot Monitor.
;    
;    Copyright 2004-2007, SOC Robotics, Inc.  All rights reserved.
;    
; ****************************************************************/
; /*
;  * Copyright (C) 2005-2007 by SOC Robotics, Inc. All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  * 4. Redistribution is only allowed in combination with SOC Machines, 
;  *    Inc. hardware products.
;  *
;  * THIS SOFTWARE IS PROVIDED BY SOC ROBOTICS, INC. AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL OC MACHINES, 
;  * INC. OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.soc-machines.com
;  */
; 
; /*
;  * $Log: P1_Monitor.c,v $
;  * Revision 0.88  2007/07/23 16:40:20  SS
;  *    Port to ATmega644
;  * Revision 0.55  2005/07/17 16:40:20  SS
;  *    2-wire interface, 8MHz clock, AVR Flash writer, XON/XOFF, 38,700baud
;  * Revision 0.52  2005/06/04 18:36:42  SS
;  * Preview release
;  *
;  */
; #include <iom644v.h>
; #include <macros.h>
; #include <string.h>
; #include <stdlib.h>
; #include <stdio.h>
; #include "P1_AVR_Uart.h"
; #include "P1_AVR_Defines.h"
; #include "P1_AVR_Extern.h"
; 
; extern int _textmode;
; 
; // Vector numbers for ATmega16
; //#pragma interrupt_handler UART_RX_Interrupt:12 UART_TX_Interrupt:13
; // Vector numbers for ATmega32
; #pragma interrupt_handler UART_RX_Interrupt:iv_USART0_RX UART_TX_Interrupt:iv_USART0_TX
; #pragma interrupt_handler TIMER0_Compare_Interrupt:iv_TIMER0_COMPA
; #pragma interrupt_handler TIMER2_Compare_Interrupt:iv_TIMER2_COMPA 
; 
; //*********************************************************
; //*********************************************************
; //     Interrupt handlers
; //*********************************************************
; //*********************************************************
; 
; //  USART serial receiver interrupt handler
; //  Flow control by XON/XOFF
; void UART_RX_Interrupt(void)
; {
	.dbline 91
; 	unsigned char data,tmphead;
; 	
; 	data = UDR0;   // read the received data
	lds R16,198
	.dbline 93
; 	
; 	tmphead = (UART_RxHead+1)&UART_RX_BUFFER_MASK;  // calculate buffer index
	lds R18,_UART_RxHead
	subi R18,255    ; addi 1
	andi R18,31
	.dbline 94
; 	UART_RxHead = tmphead;      // store new index
	sts _UART_RxHead,R18
	.dbline 95
; 	UART_RxBuf[tmphead] = data; // store received data in buffer
	ldi R24,<_UART_RxBuf
	ldi R25,>_UART_RxBuf
	mov R30,R18
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R16
	.dbline 97
; 	
; 	rxcnt++;
	lds R24,_rxcnt
	subi R24,255    ; addi 1
	sts _rxcnt,R24
	.dbline 98
; 	if(rxcnt>UART_RX_BUFFER_SIZE-1) rxcnt = UART_RX_BUFFER_SIZE-2;
	ldi R24,31
	lds R2,_rxcnt
	cp R24,R2
	brsh L2
X0:
	.dbline 98
	ldi R24,30
	sts _rxcnt,R24
L2:
	.dbline 100
; 	
; 	totalrxcnt++;
	lds R24,_totalrxcnt
	lds R25,_totalrxcnt+1
	adiw R24,1
	sts _totalrxcnt+1,R25
	sts _totalrxcnt,R24
	.dbline 101
; 	if(rxcnt>rxcntmax)  rxcntmax = rxcnt;
	lds R2,_rxcntmax
	clr R3
	lds R4,_rxcnt
	clr R5
	cp R2,R4
	cpc R3,R5
	brge L4
X1:
	.dbline 101
	mov R2,R4
	sts _rxcntmax,R2
L4:
	.dbline 104
; 
; 	// If receive buffer almost full Fire TX interrupt	
; 	if(rxcnt>(UART_RX_BUFFER_SIZE-20))  UCSR0B |= (1<<UDRIE0);
	ldi R24,12
	lds R2,_rxcnt
	cp R24,R2
	brsh L6
X2:
	.dbline 104
	lds R24,193
	ori R24,32
	sts 193,R24
L6:
	.dbline -2
L1:
	.dbline 0 ; func end
	ld R2,y+
	out 0x3f,R2
	ld R31,y+
	ld R30,y+
	ld R25,y+
	ld R24,y+
	ld R19,y+
	ld R18,y+
	ld R16,y+
	ld R5,y+
	ld R4,y+
	ld R3,y+
	ld R2,y+
	reti
	.dbsym r data 16 c
	.dbsym r tmphead 18 c
	.dbend
	.dbfunc e UART_TX_Interrupt _UART_TX_Interrupt fV
;        tmptail -> R16
	.even
_UART_TX_Interrupt::
	st -y,R2
	st -y,R3
	st -y,R16
	st -y,R17
	st -y,R24
	st -y,R25
	st -y,R30
	st -y,R31
	in R2,0x3f
	st -y,R2
	.dbline -1
	.dbline 117
; //	if((rxcnt>(UART_RX_BUFFER_SIZE-10))&&(xoffsent==NO)&&(enablexonoff==YES)) {
; //	if((rxcnt>(UART_RX_BUFFER_SIZE-10))&&(xoffsent==NO)) {
; 	// If tx buffer is empty then transmit xoff else signal tx to send xoff
; //	    sendxonxoff = YES;
; //		xoffsent = YES;
; //		UCSRB |= (1<<UDRIE);  // Fire TX interrupt	
; //		}
; }
; 
; //  UART transmit interrupt handler
; //  Flow control by XON/XOFF
; void UART_TX_Interrupt(void)
; {
	.dbline 121
; 	unsigned char tmptail;
; 
; 	// Check if all data has been transmitted
; 	if(UART_TxHead != UART_TxTail)  {
	lds R2,_UART_TxTail
	lds R3,_UART_TxHead
	cp R3,R2
	brne X13
	xjmp L9
X13:
X3:
	.dbline 121
	.dbline 123
; 	    // Check chars in rx buffer - if too many - transmit XOFF
; 		if((rxcnt>(UART_RX_BUFFER_SIZE-20))&&(xoffsent==NO)) {
	ldi R24,12
	lds R2,_rxcnt
	cp R24,R2
	brsh L11
X4:
	lds R2,_xoffsent
	tst R2
	brne L11
X5:
	.dbline 123
	.dbline 124
; 		    UDR0 = XOFF;
	ldi R24,19
	sts 198,R24
	.dbline 125
; 			xoffsent = YES;
	ldi R24,1
	sts _xoffsent,R24
	.dbline 126
; 			xofftransmitted = YES;
	sts _xofftransmitted,R24
	.dbline 127
; 			}
	xjmp L10
L11:
	.dbline 128
; 		else if((rxcnt<10)&&(xoffsent==YES)) {
	lds R24,_rxcnt
	cpi R24,10
	brsh L13
X6:
	lds R24,_xoffsent
	cpi R24,1
	brne L13
X7:
	.dbline 128
	.dbline 129
; 		    UDR0 = XON;
	ldi R24,17
	sts 198,R24
	.dbline 130
; 			xoffsent = NO;
	clr R2
	sts _xoffsent,R2
	.dbline 131
; 		    }
	xjmp L10
L13:
	.dbline 137
; //	    if((sendxonxoff==YES)&&(enablexonoff==YES))  {
; //			 UDR = XOFF;
; //			 xoffsent = YES;
; //			 sendxonxoff = NO;
; //			 }
; 		else {
	.dbline 139
; 			 // Calculate buffer index
; 			 tmptail = (UART_TxTail + 1) & UART_TX_BUFFER_MASK;
	lds R16,_UART_TxTail
	subi R16,255    ; addi 1
	andi R16,31
	.dbline 140
; 			 UART_TxTail = tmptail;     // Store new index
	sts _UART_TxTail,R16
	.dbline 141
; 			 UDR0 = UART_TxBuf[tmptail]; // Start transmission
	ldi R24,<_UART_TxBuf
	ldi R25,>_UART_TxBuf
	mov R30,R16
	clr R31
	add R30,R24
	adc R31,R25
	ldd R2,z+0
	sts 198,R2
	.dbline 142
; 			 if(UART_TxBuf[tmptail]==XON) {
	mov R30,R16
	clr R31
	add R30,R24
	adc R31,R25
	ldd R24,z+0
	cpi R24,17
	brne L10
X8:
	.dbline 142
	.dbline 143
; 			 	  xoffsent = NO;
	clr R2
	sts _xoffsent,R2
	.dbline 144
; 				  xonsent = NO;
	sts _xonsent,R2
	.dbline 145
; 				  }
	.dbline 146
; 			 }
	.dbline 147
; 		}
	xjmp L10
L9:
	.dbline 148
; 	else  {  // Check chars in rx buffer - if too many trans XOFF
	.dbline 149
; 		if((rxcnt>(UART_RX_BUFFER_SIZE-20))&&(xoffsent==NO)) {
	ldi R24,12
	lds R2,_rxcnt
	cp R24,R2
	brsh L17
X9:
	lds R2,_xoffsent
	tst R2
	brne L17
X10:
	.dbline 149
	.dbline 150
; 		    UDR0 = XOFF;
	ldi R24,19
	sts 198,R24
	.dbline 151
; 			xoffsent = YES;
	ldi R24,1
	sts _xoffsent,R24
	.dbline 152
; 			}
	xjmp L18
L17:
	.dbline 153
; 		else if((rxcnt<10)&&(xoffsent==YES)) {
	lds R24,_rxcnt
	cpi R24,10
	brsh L19
X11:
	lds R24,_xoffsent
	cpi R24,1
	brne L19
X12:
	.dbline 153
	.dbline 154
; 		    UDR0 = XON;
	ldi R24,17
	sts 198,R24
	.dbline 155
; 			xoffsent = NO;
	clr R2
	sts _xoffsent,R2
	.dbline 156
; 		    }
	xjmp L20
L19:
	.dbline 162
; //		if((sendxonxoff==YES)&&(enablexonoff==YES)) {
; //			 UDR = XOFF;
; //			 xoffsent = YES;
; //			 sendxonxoff = NO;
; //			 }
; 		else UCSR0B &= ~(1<<UDRIE0); // Disable UDRE interrupt
	lds R24,193
	andi R24,223
	sts 193,R24
L20:
L18:
	.dbline 163
; 		}
L10:
	.dbline -2
L8:
	.dbline 0 ; func end
	ld R2,y+
	out 0x3f,R2
	ld R31,y+
	ld R30,y+
	ld R25,y+
	ld R24,y+
	ld R17,y+
	ld R16,y+
	ld R3,y+
	ld R2,y+
	reti
	.dbsym r tmptail 16 c
	.dbend
	.dbfunc e TIMER0_Compare_Interrupt _TIMER0_Compare_Interrupt fV
	.even
_TIMER0_Compare_Interrupt::
	st -y,R2
	st -y,R3
	st -y,R4
	st -y,R5
	st -y,R24
	st -y,R25
	in R2,0x3f
	st -y,R2
	.dbline -1
	.dbline 170
; }
; 
; //  Timer0 interrupts every msec - This routines decrements 
; //  countdown timers - other routines can control timing to 
; //  within 1 msec by monitoring these software timers
; void  TIMER0_Compare_Interrupt(void)
; {
	.dbline 171
;  	if(mseccountdown1>0)  mseccountdown1--;
	clr R2
	clr R3
	lds R4,_mseccountdown1
	lds R5,_mseccountdown1+1
	cp R2,R4
	cpc R3,R5
	brge L22
X14:
	.dbline 171
	movw R24,R4
	sbiw R24,1
	sts _mseccountdown1+1,R25
	sts _mseccountdown1,R24
L22:
	.dbline 172
;  	if(mseccountdown2>0)  mseccountdown2--;
	clr R2
	clr R3
	lds R4,_mseccountdown2
	lds R5,_mseccountdown2+1
	cp R2,R4
	cpc R3,R5
	brge L24
X15:
	.dbline 172
	movw R24,R4
	sbiw R24,1
	sts _mseccountdown2+1,R25
	sts _mseccountdown2,R24
L24:
	.dbline 173
; 	if(mseccountdown3>0)  mseccountdown3--;
	clr R2
	clr R3
	lds R4,_mseccountdown3
	lds R5,_mseccountdown3+1
	cp R2,R4
	cpc R3,R5
	brge L26
X16:
	.dbline 173
	movw R24,R4
	sbiw R24,1
	sts _mseccountdown3+1,R25
	sts _mseccountdown3,R24
L26:
	.dbline 174
; 	if(flashcountdown>0)  flashcountdown--;
	clr R2
	clr R3
	lds R4,_flashcountdown
	lds R5,_flashcountdown+1
	cp R2,R4
	cpc R3,R5
	brge L28
X17:
	.dbline 174
	movw R24,R4
	sbiw R24,1
	sts _flashcountdown+1,R25
	sts _flashcountdown,R24
L28:
	.dbline -2
L21:
	.dbline 0 ; func end
	ld R2,y+
	out 0x3f,R2
	ld R25,y+
	ld R24,y+
	ld R5,y+
	ld R4,y+
	ld R3,y+
	ld R2,y+
	reti
	.dbend
	.dbfunc e TIMER2_Compare_Interrupt _TIMER2_Compare_Interrupt fV
	.even
_TIMER2_Compare_Interrupt::
	st -y,R2
	st -y,R3
	st -y,R4
	st -y,R5
	st -y,R16
	st -y,R17
	st -y,R24
	st -y,R25
	in R2,0x3f
	st -y,R2
	.dbline -1
	.dbline 180
; }
; 
; //  Real Time Clock interrupts every 4msec - This routine decrements 
; //  countdown timers and maintains the watch clock
; void  TIMER2_Compare_Interrupt(void)
; {
	.dbline 181
;  	if(rtccountdown1>0)  rtccountdown1--;
	clr R2
	clr R3
	lds R4,_rtccountdown1
	lds R5,_rtccountdown1+1
	cp R2,R4
	cpc R3,R5
	brge L31
X18:
	.dbline 181
	movw R24,R4
	sbiw R24,1
	sts _rtccountdown1+1,R25
	sts _rtccountdown1,R24
L31:
	.dbline 182
;  	if(rtccountdown2>0)  rtccountdown2--;
	clr R2
	clr R3
	lds R4,_rtccountdown2
	lds R5,_rtccountdown2+1
	cp R2,R4
	cpc R3,R5
	brge L33
X19:
	.dbline 182
	movw R24,R4
	sbiw R24,1
	sts _rtccountdown2+1,R25
	sts _rtccountdown2,R24
L33:
	.dbline 183
; 	if(rtccountdown3>0)  rtccountdown3--;
	clr R2
	clr R3
	lds R4,_rtccountdown3
	lds R5,_rtccountdown3+1
	cp R2,R4
	cpc R3,R5
	brge L35
X20:
	.dbline 183
	movw R24,R4
	sbiw R24,1
	sts _rtccountdown3+1,R25
	sts _rtccountdown3,R24
L35:
	.dbline 184
; 	if(rtccountdown4>0)  rtccountdown4--;
	clr R2
	clr R3
	lds R4,_rtccountdown4
	lds R5,_rtccountdown4+1
	cp R2,R4
	cpc R3,R5
	brge L37
X21:
	.dbline 184
	movw R24,R4
	sbiw R24,1
	sts _rtccountdown4+1,R25
	sts _rtccountdown4,R24
L37:
	.dbline 187
; 	
; //	if(!(rtcclockcnt++)) {
; 	if(rtcclockcnt++==0) {
	lds R2,_rtcclockcnt
	clr R3
	mov R24,R2
	subi R24,255    ; addi 1
	sts _rtcclockcnt,R24
	tst R2
	brne L39
X22:
	.dbline 187
	.dbline 189
; 	    //rtcclockcnt = 0;
; 	    if(seconds++>=59) {
	lds R2,_seconds
	clr R3
	mov R24,R2
	subi R24,255    ; addi 1
	sts _seconds,R24
	mov R24,R2
	cpi R24,59
	brlo L41
X23:
	.dbline 189
	.dbline 190
; 		    seconds = 0;
	clr R2
	sts _seconds,R2
	.dbline 191
; 			if(minutes++>=59) {
	lds R16,_minutes
	clr R17
	mov R24,R16
	subi R24,255    ; addi 1
	sts _minutes,R24
	cpi R16,59
	brlo L43
X24:
	.dbline 191
	.dbline 192
; 			    minutes = 0;
	sts _minutes,R2
	.dbline 193
; 				if(hours++>=23) {
	lds R16,_hours
	clr R17
	mov R24,R16
	subi R24,255    ; addi 1
	sts _hours,R24
	cpi R16,23
	brlo L45
X25:
	.dbline 193
	.dbline 194
; 				    hours = 0;
	sts _hours,R2
	.dbline 195
; 					days++;
	lds R24,_days
	subi R24,255    ; addi 1
	sts _days,R24
	.dbline 196
; 					}
L45:
	.dbline 197
; 				}
L43:
	.dbline 198
; 			}
L41:
	.dbline 199
; 		}
L39:
	.dbline -2
L30:
	.dbline 0 ; func end
	ld R2,y+
	out 0x3f,R2
	ld R25,y+
	ld R24,y+
	ld R17,y+
	ld R16,y+
	ld R5,y+
	ld R4,y+
	ld R3,y+
	ld R2,y+
	reti
	.dbend
; }
