/**************************************************************

   Program Title:  P1 AVR Boot/Monitor
   
   Program Name:  P1_AVR_Defines.h		  Version: 0.90
   
   Author:  SS	  				  		  Date:  August 10, 2005
   
   Compiled with ImageCraft ICCAVR Standard V6.29
   
   Copyright 2004-2005, SOC Robotics, Inc.  All rights reserved.
   
****************************************************************/
/*
 * Copyright (C) 2005 by SOC Robotics, Inc. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holders nor the names of
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 * 4. Redistribution is only allowed in combination with SOC Machines, 
 *    Inc. hardware products.
 *
 * THIS SOFTWARE IS PROVIDED BY SOC ROBOTICS, INC. AND CONTRIBUTORS
 * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL OC MACHINES, 
 * INC. OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
 * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * For additional information see http://www.soc-machines.com
 */
/*
 * $Log: P1_Monitor.c,v $
 * Revision 0.55  2005/07/17 16:40:20  SS
 *    2-wire interface, 8MHz clock, AVR Flash writer, XON/XOFF, 38,700baud
 * Revision 0.52  2005/06/04 18:36:42  SS
 * Preview release
 *
 */

//  EEPROM Definitions
#define   MAJORVER   	 0
#define   MINORVER       91

// P1 processor
#define   PROCESSORTYPE  70  
#define   ETHERNETMACID  "002078E11156"
#define   IPADDRESS      "256.128.0.24"
#define   IPMASK         "256.256.256.0"
#define   IPGATEWAY		 "256.45.25.0"
#define   USERID		 "PIRANA1"
#define   PASSWORD       "SECRET"

// Other definitions
#define  LEEPROM   		 'e'
#define  LAVRFLASH 		 'a'
#define  LFLASH    		 'f'
#define  BOOTMODE0 		 '0'
#define  BOOTMODE1 		 '1'
#define  BOOTMODE2 		 '2'
#define  BOOTMODE3 		 '3'

#define  BAUDRATE2400	 204
#define  BAUDRATE4800	 102
#define  BAUDRATE9600    50
#define  BAUDRATE19200	 25
#define  BAUDRATE38400   12
#define  BAUDRATE57600   9

// Serial Flash
#define	 FLASHBYTESPERPAGE 264
#define  SF_READ_CONT	 0xE8
#define  SF_READ_BUFFER1 0x54
#define  SF_READ_BUFFER2 0x56
#define  SF_WRITE_BUFFER1 0x84
#define  SF_WRITE_BUFFER2 0x87
#define  SF_BUF1_TO_FLASH_ERASE 0x83
#define  SF_BUF2_TO_FLASH_ERASE 0x86
#define  SF_BUF1_TO_FLASH_NOERASE 0x88
#define  SF_BUF2_TO_FLASH_NOERASE 0x89
#define  SF_FLASH_TO_BUF1 0x53
#define  SF_FLASH_TO_BUF2 0x55
#define  SF_PAGE_ERASE	  0x81
#define  SF_BLOCK_ERASE	  0x50
#define  SF_READ_STATUS	  0xD7
#define	 HIGH		     1
#define	 LOW			 2
#define  READCONTINUOUS  1
#define  READBUFFER      2
#define	 AT45DB041ID  	 0x1C
#define	 AT45DB081ID  	 0x24
#define	 AT45DB161ID  	 0x2C
#define	 AT45DB321ID  	 0x34
#define	 AT45DB642ID  	 0x3C
#define  FLASHIDMASK	 0x3C
#define  FLASHCHIP_1	 1
#define  FLASHCHIP_2	 2

// Misc defines
#define 	NO  		  0x00
#define 	YES 		  0x01
#define 	ON  		  0x00
#define 	OFF 		  0x01
#define 	DEBUG 		  0

// TWI definitions
#define   TWI_GENERAL_CALL_ON  1
#define   TWI_SLAVE_ADDRESS 0x15
#define   TWI_START   		0x08
#define   TWI_STOP    		0xA0
#define   MT_SLA_ACK  		0x18
#define   MT_DATA_ACK 		0x28
#define   SR_WRITE_COMMAND 0x60
#define   SR_READ_COMMAND  0xA8
#define   SLA_W		  	   0x00
#define   SLA_R		  	   0x01
#define   QUIET 	  	   1
#define   VERBOSE	  	   2


