#include <defBF532.h>
.section program;
/**********************************************************/
/**********************Pre-Init Section************************/ 

	[--SP] = ASTAT;   /* Stack Pointer (SP) is set to the end of */ 
	[--SP] = RETS;    /* scratchpad memory (0xFFB00FFC) */ 
	[--SP] = (r7:0);  /* by the on-chip boot ROM */ 
	[--SP] = (p5:0); 
	[--SP] = I0;[--SP] = I1;[--SP] = I2;[--SP] = I3; 
	[--SP] = B0;[--SP] = B1;[--SP] = B2;[--SP] = B3; 
	[--SP] = M0;[--SP] = M1;[--SP] = M2;[--SP] = M3; 
	[--SP] = L0;[--SP] = L1;[--SP] = L2;[--SP] = L3; 

/**********************************************************/
/****** Init Code Section *********************************/

/****** PLL Setup **************/
//  Two master clock rates - fast SDRAM and slow SDRAM
//  Some P1's operate at fast SDRAM rates - others don't
Setup_PLL:
	P0.L = lo(PLL_CTL);
	P0.H = hi(PLL_CTL);    // PLL Control Register 
//	R0 = 0x3A00(Z);		   //  391.5MHz cclk
	R0 = 0x1E00(Z);		   //  405.0MHz cclk
	W[P0] = R0;
	
	P0.L = lo(PLL_DIV);
	P0.H = hi(PLL_DIV);    // PPL Divide Register
//	R0 = 0x0016(Z);		   //  130.00MHz sclk
	R0 = 0x0004(Z);		   //  101.25MHz sclk
	W[P0] = R0;
	IDLE;
	SSYNC;
	
/****** SDRAM Setup **************/
Setup_SDRAM:
	P0.L = lo(EBIU_SDRRC);
	P0.H = hi(EBIU_SDRRC);      // SDRAM Refresh Rate Control Register
	R0 = 0x0817(Z);
	W[P0] = R0;
	SSYNC;
	
	P0.L = lo(EBIU_SDBCTL);
	P0.H = hi(EBIU_SDBCTL);    // SDRAM Memory Bank Control Register
	R0 = 0x0013(Z);
	W[P0] = R0;
	SSYNC;
	
	P0.L = lo(EBIU_SDGCTL);
	P0.H = hi(EBIU_SDGCTL);    // SDRAM Memory Global Control Register
	R0.H = 0x0091;
	R0.L = 0x998D;
	[P0] = R0;
	SSYNC;

/**********************************************************/
	L3 = [SP++]; L2 = [SP++]; L1 = [SP++]; L0 = [SP++]; 
	M3 = [SP++]; M2 = [SP++]; M1 = [SP++]; M0 = [SP++]; 
	B3 = [SP++]; B2 = [SP++]; B1 = [SP++]; B0 = [SP++]; 
	I3 = [SP++]; I2 = [SP++]; I1 = [SP++]; I0 = [SP++]; 
	(P5:0) = [SP++];   // Restore registers from stack
	(R7:0) = [SP++];
	RETS = [SP++];
	ASTAT = [SP++];

/**********************************************************/
	RTS;
	

