// **************************************************************
//
//  File:  OV9620.h			Version: 0.45
//
//  Date:  Oct 3, 2008		
//
//  ICM109S Definitions for CM130 1.3Megapixel Digital Camera Module
//
//  Copyright 2004-2008, SOC Robotics, Inc.  All rights reserved.
//
// **************************************************************
/*
 * Copyright (C) 2005-2008 by SOC Robotics, Inc. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holders nor the names of
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 * 4. Redistribution is only allowed in combination with SOC Machines, 
 *    Inc. hardware products.
 *
 * THIS SOFTWARE IS PROVIDED BY SOC ROBOTICS, INC. AND CONTRIBUTORS
 * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL OC MACHINES, 
 * INC. OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
 * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * For additional information see http://www.soc-machines.com
 */

/*
 * $Log: OV9620.h,v $
 * Revision 0.54  2008/06/04 18:36:42  steve
 * Preview release
 *
 */
#define   OV9620_Write_ADD			0x60
#define	  OV9620_Read_ADD			0x61
//
//  Sub-Address Register Definitions
//
#define   CM130_AGCGAIN				0x00
#define   CM130_BLUEGAIN			0x01
#define   CM130_REDGAIN				0x02
#define   CM130_COMA				0x03
#define   CM130_COMB				0x04
#define   CM130_BAVG				0x05
#define   CM130_GEAVG				0x06
#define   CM130_GOAVG				0x07
#define   CM130_RAVG				0x08
#define   CM130_COMC				0x09
#define   CM130_PIDH				0x0A  // Product ID
#define   CM130_PIDL				0x0B
#define   CM130_COMD				0x0C
#define   CM130_COME				0x0D
#define   CM130_COMF				0x0E
#define   CM130_COMG				0x0F
#define   CM130_AEC					0x10
#define   CM130_CLKRC				0x11
#define   CM130_COMH				0x12
#define   CM130_COMI				0x13
#define   CM130_COMJ				0x14
#define   CM130_COMK				0x15
#define   CM130_FSD					0x16
#define   CM130_HREFST				0x17
#define   CM130_HREFEND				0x18
#define   CM130_VSTRT				0x19
#define   CM130_VEND				0x1A
#define   CM130_PSHFT				0x1B
#define   CM130_MIDH				0x1C
#define   CM130_MIDL				0x1D
#define   CM130_RESERVED			0x1E
#define   CM130_LAEC				0x1F
#define   CM130_BOFF				0x20
#define   CM130_GEOFF				0x21
#define   CM130_GOOFF				0x22
#define   CM130_ROFF				0x23
#define   CM130_AEW					0x24
#define   CM130_AEB					0x25
#define   CM130_W					0x26
#define   CM130_BBIAS				0x27
#define   CM130_GEBIAS				0x28
#define   CM130_GOBIAS				0x29
#define   CM130_COML				0x2A
#define   CM130_FRARL				0x2B
#define   CM130_RBIAS				0x2C
#define   CM130_ADDVSL				0x2D
#define   CM130_ADDVSH				0x2E
#define   CM130_YAVG				0x2F
#define   CM130_HSDY				0x30
#define   CM130_HEDY				0x31
#define   CM130_COMM				0x32
#define   CM130_CHLF				0x33
#define   CM130_VGAP				0x34
#define   CM130_VBLM				0x35
#define   CM130_VCHG				0x36
#define   CM130_ADC					0x37
#define   CM130_ACOM				0x37
#define   CM130_ACOM2				0x37

//  Register Settings

